#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_Synthesis.h"
std::auto_ptr<M_Synthesis> M_Synthesis::msSingleton(nullptr);

int M_Synthesis::GetCount()
{
	return (int)mMapData.size();
}

const M_SynthesisData* M_Synthesis::GetData(int Id)
{
	auto it = mMapData.find(Id);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_SynthesisData>& M_Synthesis::GetMapData()
{
	return mMapData;
}

void M_Synthesis::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_Synthesis.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_SynthesisData data;
		data.mId = element->IntAttribute("Id");
		data.mType = element->IntAttribute("Type");
		data.mneedItem = element->IntAttribute("needItem");
		data.mneedCount = element->IntAttribute("needCount");
		data.mItemName = element->Attribute("ItemName");
		data.mitemId = element->IntAttribute("itemId");
		data.mitemCount = element->IntAttribute("itemCount");
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_Synthesis Loaded. Load Data:%u", mMapData.size());
}

void M_Synthesis::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_Synthesis");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_Synthesis");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_SynthesisData data;
		LuaCfgHelper::readInt(L, "Id", data.mId);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readInt(L, "needItem", data.mneedItem);
		LuaCfgHelper::readInt(L, "needCount", data.mneedCount);
		LuaCfgHelper::readString(L, "ItemName", data.mItemName);
		LuaCfgHelper::readInt(L, "itemId", data.mitemId);
		LuaCfgHelper::readInt(L, "itemCount", data.mitemCount);
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_Synthesis Loaded. Load Data:%u", mMapData.size());
}

void M_Synthesis::Reload()
{
	mMapData.clear();
	Load();
}

M_Synthesis* M_Synthesis::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_Synthesis());
	}
	return msSingleton.get();
}

void M_Synthesis::Release()
{
	msSingleton.reset(nullptr);
}
